VERSION 2.00
Begin Form AlarmForm 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Alarm!"
   ClientHeight    =   795
   ClientLeft      =   3570
   ClientTop       =   5550
   ClientWidth     =   2625
   ClipControls    =   0   'False
   Height          =   1200
   Icon            =   ALARM.FRX:0000
   Left            =   3510
   LinkTopic       =   "Form2"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   795
   ScaleWidth      =   2625
   Top             =   5205
   Width           =   2745
   WindowState     =   1  'Minimized
   Begin Timer Timer1 
      Interval        =   10000
      Left            =   2760
      Top             =   120
   End
   Begin Label lblTime 
      FontBold        =   -1  'True
      FontItalic      =   0   'False
      FontName        =   "MS Sans Serif"
      FontSize        =   13.5
      FontStrikethru  =   0   'False
      FontUnderline   =   0   'False
      Height          =   495
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   2415
   End
End
Option Explicit
Dim FileName, MaxTimes, OldFileDateTime
Dim AlarmArray(200, 0 To 3)
Const MINIMIZED = 1

Sub Form_Load ()
    FileName = Command ' Get command line filename
    If FileName = "" Then
	MsgBox "Please call with 'ALARM C:\ALARM.INI'"
	End
    End If
    ReadINIFile
End Sub

Sub Form_Resize ()
    If WindowState = MINIMIZED Then     ' If form is minimized
	SetCaptionTime                  ' display time in caption.
    Else
	Caption = "Alarm!"
    End If
End Sub

Sub ReadINIFile ()
    Dim temp1, temp2
    MaxTimes = 0
    If Dir(FileName) <> "" Then
	Open FileName For Input As #1
	Do While Not EOF(1)
	    MaxTimes = MaxTimes + 1
	    Line Input #1, AlarmArray(MaxTimes, 0) ' ID Num
	    Line Input #1, AlarmArray(MaxTimes, 1) ' Message
	    Line Input #1, temp1                   ' Date
	    Line Input #1, temp2                   ' Time
	    Line Input #1, AlarmArray(MaxTimes, 3) ' Sounded Yet?
	    AlarmArray(MaxTimes, 2) = CVDate(temp1 + " " + temp2)
	Loop
	Close #1
	OldFileDateTime = FileDateTime(FileName)
    Else
	MsgBox "Could Not find file " + FileName
	End
    End If
End Sub

Sub SetCaptionTime ()
    Caption = Format(Time, "Medium Time")   ' Display time using medium time format.
End Sub

Sub Timer1_Timer ()
    Dim x, Dirty, OFDT
    If lblTime.Caption <> CStr(Time) Then
	' It's now a different second than the one displayed.
	If FileDateTime(FileName) <> OldFileDateTime Then
	    ' Re read file
	    ReadINIFile
	End If
	Dirty = False
	For x = 1 To MaxTimes
	    'MsgBox "Comparing " & AlarmArray(x, 2) & " and " & Date & " " & Time
	    If (Date + Time) >= AlarmArray(x, 2) And Not AlarmArray(x, 3) Then
		Beep
		MsgBox AlarmArray(x, 1) + " at " + Format(AlarmArray(x, 2), "Short Time") + " on " + Format(AlarmArray(x, 2), "Short Date")
		AlarmArray(x, 3) = True
		Dirty = True
	    End If
	Next x
	If Dirty Then
	    ' Write out file
	    WriteINIFile
	End If
	If WindowState = MINIMIZED Then
	    'If minimized then update form Caption every minute
	    If Minute(CVDate(Caption)) <> Minute(Time) Then SetCaptionTime
	Else
	    'Else update label Caption every second
	    lblTime.Caption = Time
	End If
    End If
End Sub

Sub WriteINIFile ()
    Dim x
    Open FileName For Output As #1
    For x = 1 To MaxTimes
	Print #1, AlarmArray(x, 0)
	Print #1, AlarmArray(x, 1)
	Print #1, Format(AlarmArray(x, 2), "Short Date")
	Print #1, Format(AlarmArray(x, 2), "Short Time")
	Print #1, AlarmArray(x, 3)
    Next x
    Close #1
End Sub

